<template lang="pug">
  .chatroom.flex.flex-column.h-100
    .pa3.flex-auto.overflow-y-auto.overflow-x-hidden(ref="threads")
      chat-log-view(
        :logs="logs"
        :showTime="true"
        :is-loading-history="isLoadingHistory"
        :no-more-history="noMoreHistory"
      )
    .chatroom__tooltip.bt.pa2.b--light-silver.flex
      slot(name="left-tooltip")
      .flex-auto.flex.flex-column
        textarea.w-100.f6.bn.flex-auto(
          placeholder="輸入訊息..."
          v-model.trim="message"
          ref="textarea"
          @keydown.enter="sendMsg"
        )
        .flex.justify-between
          .chatroom__leftaction
            canned-msg-selector(
              @change="applyMsg"
              :ticketId="ticketId"
            )
          slot(name="bottom-tooltip")
          .chatroom__rightaction
            b-button(
              type="is-warning"
              @click="sendMsg"
              :disabled="!canSendMessage"
            ) 送出訊息
</template>
<script>
import _ from 'lodash'
import { chat, feathers } from '~/utils/api'
import ChatLogView from '~/components/ChatLogView'
import CannedMsgSelector from '~/components/CannedMsgSelector'

const BOTTOM_BUFFER = 16
const TOP_BUFFER = 100
const SCROLL_DEBOUNCE = 100

// TODO: apply hard core image ready hook like this:
// https://gist.github.com/kamilogorek/8819542
const SIMPLE_IMG_LOAD_TIME = 100

export default {
  components: {
    ChatLogView,
    CannedMsgSelector
  },
  props: {
    channelId: {
      type: String,
      required: true
    },
    channelType: {
      type: String,
      default: 'facebook'
    },
    ticketId: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      chat: null,
      rawChatCursor: null,
      isLoadingHistory: false,
      logs: [],

      message: '',
      appendHandler: null
    }
  },
  computed: {
    booking () {
      return this.chat.booking || null
    },
    canSendMessage () {
      return !!this.message
    },
    noMoreHistory () {
      return this.rawChatCursor && !this.rawChatCursor.prevId
    }
  },
  watch: {
    channelId () {
      this.initChats()
    },
    channelType () {
      this.initChats()
    }
  },
  async created () {
    await this.initChats()
  },
  beforeDestroy () {
    this.closeWs()
  },
  mounted () {
    this.initWs()
    this.initScrollHandler()
  },
  methods: {
    disableSend () {
      this.sendMsgDisabled = true
    },
    enableSend () {
      this.sendMsgDisabled = false
    },
    applyMsg (msg) {
      this.message = msg
      this.$nextTick(() => {
        this.$refs.textarea.focus()
      })
    },
    scrollDown () {
      return new Promise((resolve) => {
        setTimeout(() => {
          const target = this.$refs.threads
          if (target) {
            target.scrollTop = target.scrollHeight
          }
          resolve()
        }, SIMPLE_IMG_LOAD_TIME)
      })
    },
    async sendMsg (event) {
      if (!this.message) {
        return
      }
      if (event.shiftKey) {
        return
      }
      event.preventDefault()
      await chat.sendMsg({
        channelType: this.channelType,
        channelId: this.channelId,
        data: this.message
      })
      this.message = ''
    },
    checkLoadingPrevLog () {
      const target = this.$refs.threads
      if (target.scrollTop < TOP_BUFFER && !this.isLoadingHistory) {
        this.loadPrevChatLog()
      }
    },
    initScrollHandler () {
      const origChecker = this.checkLoadingPrevLog
      this.checkLoadingPrevLog = _.debounce(() => {
        origChecker()
      }, SCROLL_DEBOUNCE)
      this.$refs.threads.addEventListener('scroll', this.checkLoadingPrevLog)
    },
    initWs () {
      this.appendHandler = (chat) => {
        if (chat.channelType !== this.channelType || chat.channelId !== this.channelId) {
          return
        }
        const target = this.$refs.threads
        const curHeight = target.scrollTop + target.clientHeight + BOTTOM_BUFFER
        const isAtBottom = curHeight > target.scrollHeight

        this.logs.push(chat.chatLog)
        if (isAtBottom) {
          this.scrollDown()
        }
      }

      feathers.service('chat').on('append', this.appendHandler)
    },
    closeWs () {
      feathers.service('chat').off('append', this.appendHandler)
    },
    async initChats () {
      this.isLoadingHistory = true
      this.rawChatCursor = null
      this.message = ''
      const resp = await chat.find({
        channelId: this.channelId,
        channelType: this.channelType
      })
      if (resp.length > 0) {
        this.chat = resp[0]
        this.logs = this.chat.logs
      }
      await this.loadPrevChatLog(true)
      await this.scrollDown()
      this.isLoadingHistory = false
    },
    async loadPrevChatLog (loadTillOverflow = false) {
      this.isLoadingHistory = true
      if (!this.rawChatCursor) {
        this.rawChatCursor = await chat.getRaw(this.chat.id)
      }
      if (this.rawChatCursor.prevId) {
        this.rawChatCursor = await chat.getRaw(this.rawChatCursor.prevId)
        this.logs.unshift(...this.rawChatCursor.logs)
      }
      this.isLoadingHistory = false

      if (loadTillOverflow && this.rawChatCursor.prevId) {
        const scrollTarget = this.$refs.threads
        if (scrollTarget.clientHeight >= scrollTarget.scrollHeight) {
          // no scroll bar, but we still got sth to see
          await this.loadPrevChatLog(true)
        }
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.chatroom {
  &__tooltip {
    height: 8rem;
  }
  &__tooltip {
    textarea {
      resize: none;
    }
  }
}
</style>
